/***********************************************************************
 *
 *  Copyright 2005 by Sistemas Embebidos S.A.
 *  All rights reserved.
 *
 *  $Id: i2c_eeprom.h,v 1.1 2005-09-08 13:42:41 pperez Exp $
 *  Author: Pedro Perez de Heredia
 *  Descr:  Eeprom driver. Derived from eeprom.c by Frodo Looijaard
 *          and Philip Edelbrock.
 *  
 ***********************************************************************
 *  @History:
 *     2005/01/14 : Initial version.
 ***********************************************************************/

#ifndef	_I2C_EEPROM_H_
#define _I2C_EEPROM_H_

#ifndef I2C_EEPROM_MAJOR
 #define I2C_EEPROM_MAJOR	0	// dynamic major
#endif

#ifndef I2C_EEPROM_MAX_DEVS
 #define I2C_EEPROM_MAX_DEVS	4	// max number of I2C eeproms.
#endif

typedef enum
{
	EEPROM_GEN,
	EEPROM_24C64,
	EEPROM_24C1024,
	EEPROM_UNKNOWN
}eeprom_type_t;


typedef struct
{
	eeprom_type_t	eep_id;
	unsigned int	eep_page_size;
	unsigned int	eep_size;
	char		*eep_name;
}i2c_eeprom_t;


i2c_eeprom_t i2c_eeprom_supported[] = {
	
	{ EEPROM_GEN,          0,        0,      "Generic" },
	{ EEPROM_24C64,       32,     8192,        "24C64" },
	{ EEPROM_24C1024,    256,   131072,      "24C1024" },
	{ EEPROM_GEN,          0,        0,            " " }
};



#endif // _I2C_EEPROM_H_
