/*
 *  linux/linux/drivers/spi/spi-alloc.h
 *
 *  Copyright (C) 2005 MontaVista Software, Inc <sources@mvista.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License.
 *
 */
#ifndef __SPI_ALLOC_H
#define __SPI_ALLOC_H

#include <linux/slab.h>
#include "spi-core.h"

static inline struct spi_msg *spimsg_kzalloc(void)
{
#ifdef CONFIG_SPI_CUSTOM_ALLOC
	extern struct spi_msg *__spimsg_kzalloc(void);
	return  __spimsg_kzalloc();
#else
	return kzalloc(sizeof(struct spi_msg), SLAB_KERNEL);
#endif
}

static inline void spimsg_kfree(struct spi_msg *msg)
{
#ifdef CONFIG_SPI_CUSTOM_ALLOC
	extern void __spimsg_kfree (struct spi_msg *msg);
	__spimsg_kfree(msg);
#else
	kfree(msg);
#endif
}

static inline int spimsg_init(void)
{
#ifdef CONFIG_SPI_CUSTOM_ALLOC
	extern int __spimsg_init(void);
	return __spimsg_init();
#else
	return 0;
#endif
}

static inline void spimsg_exit(void)
{
#ifdef CONFIG_SPI_CUSTOM_ALLOC
	extern void __spimsg_exit(void);
	__spimsg_exit();
#endif
}

#endif /* __SPI_ALLOC_H */
