/*
 * include/asm-arm/arch-ns9xxx/entry-macro.S
 *
 * Copyright (C) 2006 by Digi International Inc.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 */
#include <asm/hardware.h>
#include <asm/arch-ns9xxx/regs-sys.h>
#include <asm/arch-ns9xxx/irqs.h>
#include <asm/arch-ns9xxx/regs-bbus.h>
#include <asm/arch-ns9xxx/regs-bbus_bridge.h>
#include <asm/arch/regs-usb.h>

	.macro	get_irqnr_and_base, irqnr, irqstat, base, tmp
		ldr	\base, =SYS_ISA
		ldr	\irqstat, [\base]
		cmp	\irqstat, #0
		beq	1001f @ if no pending irqs we are done

		@@ 1 interrupt is active, return it's number
		ldr \base, =SYS_ISRADDR
		ldr \irqnr, [\base]
		cmp \irqnr, #IRQ_BBUSAGG
		bne 1001f @ no BBUS interrupt, return AHB IRQ directly

		@@ check which of the BBUS interrupts is active
		ldr \base, =BBUS_ISR
		ldr \irqstat, [\base]
		cmp \irqstat, #0
		beq 1001f @ no interrupt known, must be spurious. Ignore it
		@@ @TODO. Must we clear spurious interrupts?

		tst \irqstat, #1 @ test for BBUS DMA Interrupt
		bne 1003f
		tst \irqstat, #2 @ test for USB Interrupt
		bne 1005f
		mov \tmp, #4 @ tmp will be bitmask
		mov \irqnr, #IRQ_BBUS_SERBRX @ we skipped USB and DMA
		
		@@ test BBUS interrupts 
1002:
		@@ at least one bit must be 1, loop will terminate
		tst \irqstat, \tmp
		bne 1001f @ irqstat and status are set for irq received
		mov \tmp, \tmp, lsl #1
		add \irqnr, \irqnr, #1
		b 1002b

		@@ test BBUS DMA interrupts
1003:
		mov \tmp, #1 @ tmp will be bitmask
		mov \irqnr, #IRQ_BBUS_DMA_1
		ldr \base, =(BBUS_DMA_ISTAT)
		ldr \irqstat, [\base]

1004:
		@@ at least one bit must be 1, loop will terminate
		tst \irqstat, \tmp
		bne 1001f 
		mov \tmp, \tmp, lsl #1
		add \irqnr, \irqnr, #1
		b 1004b

		@@ test USB interrupts
		@@ TODO modify following code to use demux interrupts

1005:
		@@ check which USB Interrupt is active (DMA Controller 2, FIFO)
		ldr \base, =(USB_ISTAT)
		ldr \irqstat, [\base]
		mov \irqnr, #IRQ_USB_DMA
		tst \irqstat, #NS_USB_INT_GBL_DMA
		bne 1001f
		mov \irqnr, #IRQ_USB_HOST
		tst \irqstat, #NS_USB_INT_OHCI_IRQ
		bne 1001f
		@@ if it is not a DMA Interrupt, it must be FIFO
		mov \irqnr, #IRQ_USB_FIFO

1001:
	.endm

	.macro	disable_fiq
	.endm

