/*
 * include/asm-arm/arch-ns9xxx/lcd_lib/ctr_vga.h
 *
 * Copyright (C) 2006 by Digi International Inc.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 */

#ifndef __ASM_ARCH_LCDLIB_CTR_VGA_H
#define __ASM_ARCH_LCDLIB_CTR_VGA_H

#include <asm/arch/regs-lcd.h>
#include <asm/arch/hardware.h>

#define	DISP_NAME		"CTR VGA"
#define	DISP_XSIZE		(640)
#define	DISP_YSIZE		(480)


#define DISP_TIMING0		(LCD_TIMING_0_HBP( 40 ) | \
				 LCD_TIMING_0_HFP( 8 ) | \
				 LCD_TIMING_0_HSW( 96 ) | \
				 LCD_TIMING_0_PPL( (DISP_XSIZE/16)-1 ))

#define DISP_TIMING1		(LCD_TIMING_1_VBP( 25 ) | \
				 LCD_TIMING_1_VFP( 2 ) | \
				 LCD_TIMING_1_VSW( 2 ) | \
				 LCD_TIMING_1_LPP( DISP_YSIZE-1))

#define DISP_TIMING2		(LCD_TIMING_2_CPL( DISP_XSIZE-1 ) | \
				 LCD_TIMING_2_BCD | \
				 LCD_TIMING_2_IPC | \
				 LCD_TIMING_2_IHS | \
				 LCD_TIMING_2_IVS)

#define DISP_TIMING3		(0x0)

#define DISP_CONTROL		(LCD_CONTROL_WATERMARK | \
				 LCD_CONTROL_PWR | \
				 LCD_CONTROL_TFT | \
				 LCD_CONTROL_BPP_16 | \
				 LCD_CONTROL_EN)



/*
 * Specific GPIO configuration for the selected display
 */
struct ns_fb_gpio ns9xxxfb_gpios[] = { 
	 { 18, NS_GPIO_CFG_FUNC_GPIO | NS_GPIO_CFG_OUTPUT },
	 { 15, NS_GPIO_CFG_FUNC_2 },
	 { 19, NS_GPIO_CFG_FUNC_1 },
	 { 20, NS_GPIO_CFG_FUNC_1 },
	 { 21, NS_GPIO_CFG_FUNC_1 },
	 { 22, NS_GPIO_CFG_FUNC_1 },
	 { 24, NS_GPIO_CFG_FUNC_1 },
	 { 25, NS_GPIO_CFG_FUNC_1 },
	 { 26, NS_GPIO_CFG_FUNC_1 },
	 { 27, NS_GPIO_CFG_FUNC_1 },
	 { 28, NS_GPIO_CFG_FUNC_1 },
	 { 29, NS_GPIO_CFG_FUNC_1 },
	 { 30, NS_GPIO_CFG_FUNC_1 },
	 { 31, NS_GPIO_CFG_FUNC_1 },
	 { 32, NS_GPIO_CFG_FUNC_2 },
	 { 33, NS_GPIO_CFG_FUNC_2 },
	 { 34, NS_GPIO_CFG_FUNC_2 },
	 { 35, NS_GPIO_CFG_FUNC_2 },
	 { 37, NS_GPIO_CFG_FUNC_2 },
	 { 38, NS_GPIO_CFG_FUNC_2 },
	 { 39, NS_GPIO_CFG_FUNC_2 },
	 { 40, NS_GPIO_CFG_FUNC_2 },
	 { 41, NS_GPIO_CFG_FUNC_2 }
};


/*
 * Customize following functions to enable/disable the lcd
 */
inline void ns9xxxfb_lcd_power_enable(void)
{
	(void)ns9xxx_gpio_setpin(18, 0);
}

inline void ns9xxxfb_lcd_power_disable(void)
{
	(void)ns9xxx_gpio_setpin(18, 1);
}

#endif /* __ASM_ARCH_LCDLIB_CTR_VGA_H */








