/*
 * linux/include/asm-arm/arch-ns9xxx/uncompress.h
 *
 * Copyright (C) 2006 by Digi International Inc.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 */
#ifndef __ASM_ARCH_UNCOMPRESS_H
#define __ASM_ARCH_UNCOMPRESS_H

#define UARTA		((volatile u32 *)0x90200040)
#define UARTB		((volatile u32 *)0x90200000)
#define UARTC		((volatile u32 *)0x90300000)
#define UARTD		((volatile u32 *)0x90300040)

static void putc_autodetect(char c);

static volatile u32 *uart_base;

static void putc_ns9xxx(char c)
{
	int t = 0x1000;
	while (--t)
		if (*(uart_base + 2) & (1 << 3)) {
			*(volatile u8 *)(uart_base + 4) = c;
			break;
		}
}

static void putc(char c)
{
	/* check internal NS9xxx UARTS */
	if (*UARTA & (1 << 31)) {
		uart_base = UARTA;
		putc_ns9xxx(c);
	} else if (*UARTB & (1 << 31)) {
		uart_base = UARTB;
		putc_ns9xxx(c);
	} else if (*UARTC & (1 << 31)) {
		uart_base = UARTC;
		putc_ns9xxx(c);
	} else if (*UARTD & (1 << 31)) {
		uart_base = UARTD;
		putc_ns9xxx(c);
	}
}

#define arch_decomp_setup()
#define arch_decomp_wdog()

static void flush(void)
{
}

#endif /* ifndef __ASM_ARCH_UNCOMPRESS_H */
