/* linux/include/asm-arm/arch-s3c2410/spi.h
 *
 * (c) 2005 Guillaume GOURAT / NexVision <guillaume.gourat@nexvision.fr>
 *
 * based on linux/include/asm-arm/arch-s3c2410/iic.h
 *
 * S3C2410 - SPI Controller platform_device info
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * Changelog:
 *	18-Feb-2005 GG  Created file
*/

#ifndef __ASM_ARCH_SPI_H
#define __ASM_ARCH_SPI_H __FILE__

/* Notes:
 *	1) All frequencies are expressed in Hz
 *	2) A value of zero is `do not care`
*/

struct s3c2410_platform_spi {
	unsigned int	flags;
	unsigned long	bus_freq;	/* standard bus frequency */
	unsigned long	max_freq;	/* max frequency for the bus */
	unsigned long	min_freq;	/* min frequency for the bus */
};

#endif /* __ASM_ARCH_SPI_H */
