#/bin/bash

set -e
. ./common_config.sh 

BCP_URL="https://beosvn.bang-olufsen.dk/repos/HomeIntegration/TPI/BeoNetPlatform/Software/Source/BeoNetPlatform/bcplib/trunk"
EZXML_URL="https://beosvn.bang-olufsen.dk/repos/HomeIntegration/TPI/BeoNetPlatform/Software/Source/BeoNetPlatform/ezxml/trunk"
# BCP_URL="https://beosvn.bang-olufsen.dk/repos/HomeIntegration/TPI/BeoNetPlatform/Software/Source/BeoNetPlatform/bcplib/tags/v0.0.12b0"
# EZXML_URL="https://beosvn.bang-olufsen.dk/repos/HomeIntegration/TPI/BeoNetPlatform/Software/Source/BeoNetPlatform/ezxml/tags/0.0.7b0"

ODIR=bcplib_src
BDIR=bcplib
EDIR=ezxml

if false
then
rm -rf ${ODIR}
mkdir -p ${ODIR}
svn export ${BCP_URL} ${ODIR}/${BDIR}
svn info ${BCP_URL}  > ${ODIR}/svn.info
cp ${ODIR}/${BDIR}/README_T9.TXT ${ODIR}

# Export ezxml
svn export ${EZXML_URL} ${ODIR}/${EDIR}
svn info ${EZXML_URL}  > ${ODIR}/svn.info
elif false #svn co
then

rm -rf ${ODIR}
mkdir -p ${ODIR}
svn co ${BCP_URL} ${ODIR}/${BDIR}
svn co ${EZXML_URL} ${ODIR}/${EDIR}

fi






#Create Makefile for create one static library
(cat <<EOF
ROOT_PATH:=\$(shell pwd)
VPATH:=
TARGET:=mlgw

include ${BDIR}/t9.mk
include ${EDIR}/t9.mk

#OBJECTS_C := \$(addprefix ${ODIR}/obj/, \$(APP_FILES:.c=.o) )
OBJECTS_C := \$(APP_FILES:.c=.o) 

CC := arm-linux-gcc

all: libbcp.a

install:
	mkdir -p \$(DESTDIR)/include/bcp
	mkdir -p \$(DESTDIR)/include/ezxml
	cp -r ../${ODIR}/${BDIR}/Inc/bcp/*  \$(DESTDIR)/include/bcp
	cp -r ../${ODIR}/${EDIR}/Inc/ezxml/*  \$(DESTDIR)/include/ezxml
	cp libbcp.a \$(DESTDIR)/lib/

\$(OBJECTS_C):%.o:%.c
	\$(CC) -static \$< -c \$(CFLAGS) \$(ALL_INCLUDES) -DLINUX_PC -D_WITHOUT_MDNS

libbcp.a: \$(OBJECTS_C)
	arm-linux-ar rcs libbcp.a \$(OBJECTS_C)
	arm-linux-ranlib libbcp.a


EOF
) > ${ODIR}/Makefile 

cd ${ODIR}

echo "Patch........."
#patch -p0 < ../patch/bcplib_addifaddrsh.patch
echo "Make........."
make
install -d ${TARGET_DIR}
install -d ${STAGING_DIR}
make  DESTDIR=${STAGING_DIR}  install


echo "========== installing in ${TARGET_DIR} directory ==========" 
mkdir -p ${TARGET_DIR}/lib
#install mising headers
cd ../${ODIR}/${BDIR}/Src 
cp --parents `find . -name *.h` ${STAGING_DIR}/include/
cd -
#cp -dpfv ${STAGING_DIR}/lib/libbcp.a ${TARGET_DIR}/lib/
#arm-linux-strip ${TARGET_DIR}/sbin/lighttpd 
cd ..
rm -rf `find ${TARGET_DIR} | grep \.svn`
echo "========== installation finish ==========" 
