#/bin/bash

set -e
. ./common_config.sh 

URL="ftp://ftp.us.netfilter.org/pub/netfilter/iptables/"
URL="http://netfilter.org/projects/iptables/files/"
VERSION="1.4.2"
PACKAGE="iptables"


SRC_FILE="${PACKAGE}-${VERSION}.tar.bz2"
SRC_DIR="${PACKAGE}-${VERSION}"

DEPS=""

CFLAGS="-I${DIGI_DIR}/include -I${STAGING_DIR}/include "
LDFLAGS="-L${DIGI_DIR}/lib -L${STAGING_DIR}/lib "
PKG_CONFIG_PATH="${STAGING_DIR}/lib/pkgconfig"


GENERAL_CONFIG_OPTIONS="--host=arm-linux\
            --target=arm-linux\
            --prefix=/\
"

CUSTOM_CONFIG_OPTIONS="\
--with-kernel=${OS_DIR}/kernel/src \
--enable-static \
--disable-shared \
"

# CHECK DEP!
for dep in ${DEPS}
do
  if [ ! -f ${dep} ]; then
    echo "Please build first ${dep}"
    exit
  fi
done



${DOWNLOAD_CMD} ${URL}${SRC_FILE}
echo "Uncompress..."
tar jxf ${SRC_FILE}

#echo "Change dir..."
cd ${SRC_DIR}

echo "Configure...."
 PKG_CONFIG_PATH="${PKG_CONFIG_PATH}" LDFLAGS="${LDFLAGS}" CFLAGS="${CFLAGS}"\
 ./configure ${GENERAL_CONFIG_OPTIONS} ${CUSTOM_CONFIG_OPTIONS}

echo "Make........."
make || exit $?
install -d ${TARGET_DIR}
install -d ${STAGING_DIR}
make DESTDIR=${STAGING_DIR}  install

#
## we will use chroot, so we move installation directory to root_avahi:
mkdir -p ${TARGET_DIR}/sbin
cp -dpf ${STAGING_DIR}/sbin/iptables-static ${TARGET_DIR}/sbin
arm-linux-strip ${TARGET_DIR}/sbin/iptables-static
(cd ${TARGET_DIR}/sbin ; ln -s iptables-static iptables)
#
#mkdir -p ${TARGET_DIR}/jail/avahi/sbin
#cp ${STAGING_DIR}/sbin/avahi-daemon ${TARGET_DIR}/jail/avahi/sbin/avahi-daemon
#arm-linux-strip ${TARGET_DIR}/jail/avahi/sbin/avahi-daemon
#
#mkdir -p  ${TARGET_DIR}/etc/avahi/
#mkdir -p  ${TARGET_DIR}/sbin/
#cp -af ${STAGING_DIR}/etc/avahi/avahi-autoipd.action ${TARGET_DIR}/etc/avahi/
#cp ${STAGING_DIR}/sbin/avahi-autoipd ${TARGET_DIR}/sbin/
#arm-linux-strip ${TARGET_DIR}/sbin/avahi-autoipd
#
#echo "========== installation finish ==========" 
