#/bin/bash
set -e

. ./common_config.sh 

URL="http://curl.haxx.se/download/"
FILE="curl-7.18.2.tar.gz"
DIR="curl-7.18.2"
PATH="${PATH}:/local/DigiEL-4.0/bin"
  
GCONFFLAGS="--host=arm-linux\
            --target=arm-linux\
            --prefix=${STAGING_DIR}/\
            "

CCONFFLAGS="\
  --disable-file\
  --disable-ldap \
  --disable-ldaps \
  --disable-dict \
  --disable-telnet \
  --disable-tftp \
  --disable-manual \
  --enable-libgcc \
  --disable-ipv6 \
  --enable-thread \
  --disable-verbose \
  --disable-sspi \
  --disable-debug \
  --disable-crypto-auth \
  --without-ssl\
"

${DOWNLOAD_CMD} ${URL}${FILE} 
echo "Uncompress..."
tar zxf ${FILE}
echo "Change dir..."
cd ${DIR}
pwd
echo "Configure...."
 ./configure ${GCONFFLAGS} ${CCONFFLAGS}
echo "Make........."
make
mkdir -p ${TARGET_DIR}
mkdir -p ${STAGING_DIR}
make install && echo "========== installation finish ==========" || echo "========== ERROR ==========="
cp -arf  ${STAGING_DIR}/lib/libcurl.so* ${TARGET_DIR}/lib/
arm-linux-strip ${TARGET_DIR}/lib/libcurl.so.4.1.0
