#/bin/bash

set -e
. ./common_config.sh 

URL="http://www.lighttpd.net/download/"
VERSION="1.4.23"
PACKAGE="lighttpd"


SRC_FILE="${PACKAGE}-${VERSION}.tar.gz"
SRC_DIR="`pwd`/${PACKAGE}-${VERSION}"

DEPS="${STAGING_DIR}/lib/libpcre.so.0"


CFLAGS="-I${DIGI_DIR}/include -I${STAGING_DIR}/include "
LDFLAGS="-L${DIGI_DIR}/lib -L${STAGING_DIR}/lib "
PKG_CONFIG_PATH="${STAGING_DIR}/lib/pkgconfig"


GENERAL_CONFIG_OPTIONS="--host=arm-linux\
            --target=arm-linux\
            --prefix=/\
"

CUSTOM_CONFIG_OPTIONS="\
--without-bzip2 \
--with-pcre    \
--without-ldap  \
--without-mysql \
--without-kerberos5 \
--disable-lfs \
--without-lua \
--program-prefix= \
"
#"
#--program-prefix="" \
#--program-suffix="" \

# CHECK DEP!
for dep in ${DEPS}
do
  if [ ! -f ${dep} ]; then
    echo "Please build first ${dep}"
    exit
  fi
done

${DOWNLOAD_CMD} ${URL}${SRC_FILE}
echo "Uncompress..."
tar zxf ${SRC_FILE}

echo "Change dir..."
cd ${SRC_DIR}

echo "PATCH"
#patch -p1 < ../patch/lighttpd_pcre_crosscompile.patch 
patch -p1 < ../patch/lighttpd_log_server_started.patch 

echo "Configure...."
# ./autogen.sh
 PKG_CONFIG_PATH="${PKG_CONFIG_PATH}" LDFLAGS="${LDFLAGS}" CFLAGS="${CFLAGS}"\
 ac_cv_path_PCRECONFIG="pkg-config libpcre" \
 ./configure ${GENERAL_CONFIG_OPTIONS} ${CUSTOM_CONFIG_OPTIONS}

echo "Make........."
make
install -d ${TARGET_DIR}
install -d ${STAGING_DIR}
make  DESTDIR=${STAGING_DIR}  install


echo "========== installing in ${TARGET_DIR} directory ==========" 
mkdir -p ${TARGET_DIR}/lib
mkdir -p ${TARGET_DIR}/sbin

cp -dpfv ${STAGING_DIR}/lib/mod_rewrite.so ${TARGET_DIR}/lib/
cp -dpfv ${STAGING_DIR}/lib/mod_auth.so ${TARGET_DIR}/lib/
cp -dpfv ${STAGING_DIR}/lib/mod_alias.so ${TARGET_DIR}/lib/
cp -dpfv ${STAGING_DIR}/lib/mod_fastcgi.so ${TARGET_DIR}/lib/
cp -dpfv ${STAGING_DIR}/lib/mod_indexfile.so ${TARGET_DIR}/lib/
cp -dpfv ${STAGING_DIR}/lib/mod_staticfile.so ${TARGET_DIR}/lib/
cp -dpfv ${STAGING_DIR}/lib/mod_dirlisting.so ${TARGET_DIR}/lib/
arm-linux-strip ${TARGET_DIR}/lib/mod_*

cp -dpfv ${STAGING_DIR}/sbin/lighttpd ${TARGET_DIR}/sbin/
arm-linux-strip ${TARGET_DIR}/sbin/lighttpd 
## copy configuration files
cd ..
rm -rf `find ${TARGET_DIR} | grep \.svn`
echo "========== installation finish ==========" 
